unit Utils;

interface

uses Graphics, Types, Classes, SysUtils, Dialogs;

type BRenderFrame = function:TBitmap of object;

type BRect = class
               private
                rect:TRect;
               published

             end;

type BUtils = class
                public
                  txtTrue,
                  txtFalse:string;
                  flagDrawComments:boolean;
              end;

Function Rev(_s:string): string;
function getFileList(search:String; exts:TStringList): TStringList;
function Explode(delimiter : string; source : string) : TStringList;
function ExplodeWithDelimiter(delimiter : string; source : string) : TStringList;
procedure coloredTextOut(_text:string; _vars,_colors:TStringList; _canvas:TCanvas; _x,_y:word);
function coloredTextOutWidth(_text:string; _vars,_colors:TStringList; _canvas:TCanvas):word;
function FlipHorizontal(_bmp:TBitmap): TBitmap;

//function getTrue: string;    // 1.25
//function getFalse: string;   // 1.25
//function getFor: string;     // 1.25
//function getWhile: string;   // 1.25
//function getRepeat: string;  // 1.25

const commentColor:TColor = clBlack;

var vars,colors:TStringlist;
    //drawComments:boolean;
    NSDUtils:BUtils;
    
    PFEIL_CODE:byte;
    PFEIL_FONT:string;
    PFEIL_ROTATE:boolean;

implementation

uses form_main;

(*******************************************
 * BUtils
 *******************************************)


(*******************************************
 * Other
 *******************************************)

(*
function getTrue: string;
begin
 result:=mainform.strAlternativeTrue.caption;
end;

function getFalse: string;
begin
 result:=mainform.strAlternativeFalse.caption;
end;

function getFor: string;
begin
 result:=mainform.strFor.caption;
end;

function getWhile: string;
begin
 result:=mainform.strWhile.caption;
end;

function getRepeat: string;
begin
 result:=mainform.strRepeat.caption;
end;
*)


procedure drawRotated(_x,_y:integer; _canvas:TCanvas; _text:string);
var bmp,rot:TBitmap;
    y,x:word;
begin
  bmp:=TBitmap.Create;
  bmp.canvas.font:=_canvas.font;
  bmp.Width:=bmp.Canvas.TextWidth(_text);
  bmp.height:=bmp.canvas.TextHeight(_text);
  bmp.Canvas.brush:=_canvas.brush;
  bmp.canvas.fillrect(0,0,bmp.width,bmp.height);
  bmp.Canvas.TextOut(0,0,_text);

  rot:=TBitmap.create;
  rot.height:=bmp.width;
  rot.width:=bmp.height;
  rot.canvas.brush:=_canvas.brush;
  rot.Canvas.fillrect(0,0,rot.width,rot.height);

  for x:=0 to bmp.Width do
    for y:= 0 to bmp.height do
      rot.canvas.Pixels[y,bmp.width-x]:=bmp.Canvas.Pixels[x,y];

  _canvas.Draw(_x,_y,rot);

  bmp.free;
  rot.free;
end;


procedure coloredTextOut(_text:string; _vars,_colors:TStringList; _canvas:TCanvas; _x,_y:word);
var words:TStringlist;
    i,j:integer;
    width,th,tb:word;
    oldCol:TColor;
    oldFont:string;
    bmp:TBitmap;

 procedure CutInto(_del:String);
 var i:integer;
     str:TStringlist;
 begin
   str:=tStringlist.Create;
   for i:=0 to words.count-1 do
   begin
     if(_vars.IndexOf(words[i])<0)
     then str.AddStrings(ExplodeWithDelimiter(_del,words[i]))
     else str.Add(words[i]);
   end;
   words.text:=str.text;
   str.free;
 end;

begin

  words:=TStringlist.Create;
  words.Add(_text);
//   showmessage(words.text);
  for i:=0 to _vars.count-1 do
  begin
   CutInto(_vars[i]);
//   showmessage(words.text);
  end;
  CutInto('<-');
//   showmessage(words.text);
  width:=0;
  for i:=0 to words.count-1 do
  begin

    if(words[i]='<-') then
    begin
      oldFont:=_canvas.Font.Name;
      th:=_canvas.TextHeight('I');
      _canvas.Font.Name:=PFEIL_FONT;
      //_canvas.Font.Name:='Symbol';
      tb:=_canvas.TextHeight(ansitoutf8(chr(PFEIL_CODE)));

      // manually draw "pfeil"
      bmp:=TBitmap.create;
      bmp.height:=tb;
      bmp.width:=_canvas.TextWidth(ansitoutf8('O'));
      bmp.canvas.brush.color:=_canvas.brush.color;
      bmp.canvas.FillRect(0,0,bmp.width,bmp.height);
      with bmp.canvas do
      begin
        brush.color:=clBlack;
        pen.color:=clBlack;
        pen.style:=psSolid;
        pen.Width:=1;
        

        moveto(0,(bmp.height div 2));
        lineto(bmp.width, (bmp.height div 2));
        moveto(0,(bmp.height div 2)+1);
        lineto(bmp.width, (bmp.height div 2)+1);

        moveto(0,(bmp.height div 2));
        lineto(bmp.width div 4,(bmp.height div 2)-(bmp.height div 3));
        moveto(1,(bmp.height div 2));
        lineto((bmp.width div 4)+1,(bmp.height div 2)-(bmp.height div 3));

        moveto(0,(bmp.height div 2));
        lineto(bmp.width div 4,(bmp.height div 2)+1+(bmp.height div 3));
        moveto(1,(bmp.height div 2));
        lineto((bmp.width div 4)+1,(bmp.height div 2)+1+(bmp.height div 3));

      end;
      _canvas.Draw(_x+width,_y+((th-tb) div 2),bmp);
      bmp.free;

(*
      bmp:=TBitmap.create;
      bmp.height:=tb;
      bmp.width:=_canvas.TextWidth(ansitoutf8(chr(PFEIL_CODE)));
      bmp.Transparent:=true;
      {$IFDEF WIN32}
      bmp.canvas.brush.color:=_canvas.brush.color;
      bmp.canvas.FillRect(0,0,bmp.width,bmp.height);
      {$ENDIF}
      {$IFDEF LINUX}
      bmp.canvas.brush.color:=_canvas.brush.color;
      bmp.canvas.FillRect(0,0,bmp.width,bmp.height);
      {$ENDIF}
      bmp.Canvas.Font:=_canvas.font;
      bmp.Canvas.TextOut(0,0,ansitoutf8(chr(PFEIL_CODE)));
      if(PFEIL_ROTATE) then _canvas.Draw(_x+width,_y+((th-tb) div 2),FlipHorizontal(bmp))
      else _canvas.Draw(_x+width,_y+((th-tb) div 2),bmp);
      bmp.free;
*)
      width:=width+_canvas.TextWidth(ansitoutf8(chr(PFEIL_CODE)));
      _canvas.font.name:=oldFont;
    end
    else
    begin
      oldCol:=_canvas.Font.color;
      for j:=0 to _vars.count-1 do if(_vars[j]=words[i]) then
      begin
        _canvas.Font.color:=StrtoInt('$'+Rev(_colors[j]));
        _canvas.Font.Style:=[fsBold];
        if(_canvas.Font.color=clGray) then
        begin
         _canvas.Font.color:=clBlack;
         _canvas.Font.Style:=[];
        end;
      end;
      _canvas.TextOut(_x+width,_y,words[i]);
      
      width:=width+_canvas.TextWidth(words[i]);
      _canvas.Font.Style:=[];
      _canvas.font.color:=oldCol;
    end;
  end;
end;

procedure coloredTextOutPicture(_text:string; _vars,_colors:TStringList; _canva:TCanvas; _x,_y:word);
var words:TStringlist;
    i,j:integer;
    width,th,tb,x,y:word;
    oldCol:TColor;
    oldFont:string;
    bmp,output:TBitmap;

 procedure CutInto(_del:String);
 var i:integer;
     str:TStringlist;
 begin
   str:=tStringlist.Create;
   for i:=0 to words.count-1 do
   begin
     if(_vars.IndexOf(words[i])<0)
     then str.AddStrings(ExplodeWithDelimiter(_del,words[i]))
     else str.Add(words[i]);
   end;
   words.text:=str.text;
   str.free;
 end;

begin
  // create output image
  output:=TBitmap.create;
  output.Width:=_canva.Width;
  output.height:=_canva.height;
  output.canvas.font:=_canva.font;
  output.canvas.brush:=_canva.brush;
  output.Canvas.FillRect(0,0,output.width,output.height);
  // modify position
  x:=_x;
  y:=_y;
  _x:=0;
  _y:=0;

  words:=TStringlist.Create;
  words.Add(_text);
//   showmessage(words.text);
  for i:=0 to _vars.count-1 do
  begin
   CutInto(_vars[i]);
//   showmessage(words.text);
  end;
  CutInto('<-');
//   showmessage(words.text);
  width:=0;
  for i:=0 to words.count-1 do
  begin

    if(words[i]='<-') then
    begin
      oldFont:=output.canvas.Font.Name;
      th:=output.canvas.TextHeight('I');
      output.canvas.Font.Name:=PFEIL_FONT;
      //_canvas.Font.Name:='Symbol';
      tb:=output.canvas.TextHeight(ansitoutf8(chr(PFEIL_CODE)));

      bmp:=TBitmap.create;
      bmp.height:=tb;
      bmp.width:=output.canvas.TextWidth(ansitoutf8(chr(PFEIL_CODE)));
      bmp.Transparent:=true;
      {$IFDEF WIN32}
      bmp.canvas.brush.color:=output.brush.color;
      bmp.canvas.FillRect(0,0,bmp.width,bmp.height);
      {$ENDIF}
      bmp.Canvas.Font:=output.canvas.font;
      bmp.Canvas.TextOut(0,0,ansitoutf8(chr(PFEIL_CODE)));
      if(PFEIL_ROTATE) then output.canvas.Draw(_x+width,_y+((th-tb) div 2),FlipHorizontal(bmp))
      else output.canvas.Draw(_x+width,_y+((th-tb) div 2),bmp);
      bmp.free;

      //_canvas.TextOut(_x+width,_y+((th-tb)),'¨');
      //_canvas.TextOut(_x+width,_y+((th-tb) div 2),ansitoutf8(chr(PFEIL_CODE)));
      //width:=width+_canvas.TextWidth('¨');
      width:=width+output.canvas.TextWidth(ansitoutf8(chr(PFEIL_CODE)));
      output.canvas.font.name:=oldFont;
    end
    else
    begin
      oldCol:=output.canvas.Font.color;
      for j:=0 to _vars.count-1 do if(_vars[j]=words[i]) then
      begin
        output.canvas.Font.color:=StrtoInt('$'+Rev(_colors[j]));
        output.canvas.Font.Style:=[fsBold];
        if(output.canvas.Font.color=clGray) then
        begin
         output.canvas.Font.color:=clBlack;
         output.canvas.Font.Style:=[];
        end;
      end;
      output.canvas.TextOut(_x+width,_y,words[i]);
      width:=width+output.canvas.TextWidth(words[i]);
      output.canvas.Font.Style:=[];
      output.canvas.font.color:=oldCol;
    end;
  end;

  // draw image
  //output.height:=th;
  //output.width:=width;
  _canva.Draw(x,y,output);

end;

function coloredTextOutWidth(_text:string; _vars,_colors:TStringList; _canvas:TCanvas):word;
var words:TStringlist;
    i,j:integer;
    width,th,tb:word;
    oldCol:TColor;
    oldFont:string;

 procedure CutInto(_del:String);
 var i:integer;
     str:TStringlist;
 begin
   str:=tStringlist.Create;
   for i:=0 to words.count-1 do
   begin
     if(_vars.IndexOf(words[i])<0)
     then str.AddStrings(ExplodeWithDelimiter(_del,words[i]))
     else str.Add(words[i]);
   end;
   words.text:=str.text;
   str.free;
 end;

begin
  words:=TStringlist.Create;
  words.Add(_text);
//   showmessage(words.text);
  for i:=0 to _vars.count-1 do
  begin
   CutInto(_vars[i]);
//   showmessage(words.text);
  end;
  CutInto('<-');
//   showmessage(words.text);
  width:=0;
  for i:=0 to words.count-1 do
  begin
    if(words[i]='<-') then
    begin
      oldFont:=_canvas.Font.Name;
      th:=_canvas.TextHeight('I');
      _canvas.Font.Name:=PFEIL_FONT;
      tb:=_canvas.TextHeight(ansitoutf8(chr(PFEIL_CODE)));
      //_canvas.TextOut(_x+width,_y+((th-tb)),'¨');
      width:=width+_canvas.TextWidth(ansitoutf8(chr(PFEIL_CODE)));
      _canvas.font.name:=oldFont;
    end
    else
    begin
      oldCol:=_canvas.Font.color;
      for j:=0 to _vars.count-1 do if(_vars[j]=words[i]) then
      begin
        _canvas.Font.color:=StrtoInt('$'+Rev(_colors[j]));
        _canvas.Font.Style:=[fsBold];
        if(_canvas.Font.color=clGray) then
        begin
         _canvas.Font.color:=clBlack;
         _canvas.Font.Style:=[];
        end;
      end;
//      _canvas.TextOut(_x+width,_y,words[i]);
      width:=width+_canvas.TextWidth(words[i]);
      _canvas.Font.Style:=[];
      _canvas.font.color:=oldCol;
    end;
  end;
  result:=width;
end;

{
 Text_Color_Dialog.Color:=StrtoInt('$'+Rev(Box_Color.text));
 Box_Color.text:=Rev(Inttohex(Text_Color_Dialog.Color,6));
}

Function Rev(_s:string): string;
var s:string;
begin
 s:=_s;
 s[1]:=_s[5];
 s[2]:=_s[6];
 s[5]:=_s[1];
 s[6]:=_s[2];
 rev:=copy(s,1,6);
end;

function Explode(delimiter : string; source : string) : TStringList;
var
  c : word;
begin
  Result:=TStringList.Create; 
  c := 0;
  while source <> '' do
  begin
    if Pos(delimiter, source) > 0 then 
    begin
      Result.Add(trim(Copy(Source, 1, Pos(delimiter,source)-1)));
      Delete(Source,1 , Length(Result[c]) + Length(delimiter));
    end
    else
    begin
      Result.Add(trim(Source));
      Source := '';
    end;
    inc(c); 
  end;
end;

function ExplodeWithDelimiter(delimiter : string; source : string) : TStringList;
var
  c : word;
begin
  Result:=TStringList.Create; 
  c := 0;

  while source <> '' do
  begin
    if Pos(delimiter, source) > 0 then
    begin
      Result.Add(Copy(Source, 1, Pos(delimiter,source)-1));
      Result.Add(Copy(Source, Pos(delimiter,source),length(delimiter)));
      Delete(Source,1 , Pos(delimiter,source)+length(delimiter)-1);
    end
    else
    begin
      Result.Add(Source);
      Source := '';
    end;
    inc(c); 
  end;
end;

function getFileList(search:String; exts:TStringList): TStringList;
var sr: TSearchRec;
    FileAttrs: Integer;
    list:TStringList;
begin
 list:=TStringList.create();
 FileAttrs:=faAnyFile;

 //search:='D:\Abc-Text\Programs\Delphi\Dedis\Logs\*.log';
 if FindFirst(search, FileAttrs, sr) = 0 then
 begin
  repeat
   if (sr.Attr and FileAttrs) = sr.Attr then
   begin
    if(exts.IndexOf(AnsiUpperCase(ExtractFileExt(sr.Name)))>=0) then list.Add(sr.Name);
   end;
  until FindNext(sr) <> 0;
  FindClose(sr);
 end;
 getFileList:=list;
end;


function FlipHorizontal(_bmp:TBitmap): TBitmap;
var x,y:integer;
    rec,rec2:TRect;
begin
  result:=TBitmap.create;
  result.width:=_bmp.width;
  result.height:=_bmp.height;
  result.Transparent:=true;


  for X:=1 to result.width-1 do
  begin
      rec.Left:=x;
      rec.top:=0;
      rec.Right:=rec.left+1;
      rec.Bottom:=_bmp.height-1;

      rec2.Left:=_bmp.height-x;
      rec2.top:=0;
      rec2.Right:=rec2.Left+1;
      rec2.Bottom:=_bmp.height-1;

      //if (x mod 2 = 0) then
      result.Canvas.CopyRect(rec,_bmp.Canvas,rec2);
  end;
    
end;



begin
  PFEIL_CODE:=0;
  PFEIL_FONT:='';
  NSDUtils:=BUtils.Create;
end.
