unit class_error;

interface

uses class_element, contnrs;

type BError =   class
                 public
                   element:BElement;
                   error:UTF8string;

                   constructor create(_element:BElement; _error:ansistring);
                 private
                 protected
                end;

type BErrorList = class
                    public
                      constructor create;
                      destructor destroy; override;
                      
                     procedure add(_element:BElement; _error:ansistring);
                     function get(_id:word): BError;
                     procedure clear;
                     function containsError(_error:string): boolean;
                     function count:word;
                    private
                      items:TObjectList;
                    protected
                    published
                  end;


implementation

constructor BError.create(_element:BElement; _error:ansistring);
begin
  element:=_element;
  {$IFDEF WIN32}
  error:=_error;
  {$ELSE}
  error:=ansitoutf8(_error);
  {$ENDIF}
  
end;

constructor BErrorList.create;
begin
  inherited create;
  items:=TObjectlist.create(False);
end;

destructor BErrorList.destroy;
begin
   clear;
  items.free;
  inherited destroy;
end;

procedure BErrorList.clear;
var e:BError;
begin
  while(items.count<>0) do
  begin
    e:=(items[0] as BError);
    items.remove(e);
    e.free;
  end;
end;

procedure BErrorList.add(_element:BElement; _error:ansistring);
var e:BError;
begin
  e:=BError.create(_element,_error);
  items.add(e);
end;

function BErrorList.get(_id:word): BError;
var i:word;
begin
  result:=(items[_id] as BError);
end;

function BErrorList.containsError(_error:string): boolean;
var i:word;
    e:BError;
begin
  result:=false;
  if(items.count>0) then
    for i:=0 to items.count-1 do
    begin
      e:=(items[i] as BError);
      if(e.error=_error) then result:=true;
    end;
end;

function BErrorList.count:word;
begin
  result:=items.count;
end;

end.
