unit class_jump;

interface

uses Graphics,
     Types,
     ContNrs,
     Dialogs,
     class_element,
     StrUtils,
     RegExpr,
     SysUtils,
     Classes,
     Utils,
     class_instruction;

type BJump =
                class(BInstruction)
                 public
                   function PrepareDraw(_canvas:TCanvas): TRect; override; // passes back the dimensions of the square
                   procedure Draw(_canvas:TCanvas; _top_left:TRect); override; // passes back the dimensions of the square
                   function getXml:UTF8string; override;
                   function getACopyOf:BElement; override;                      // 1.26
                 private
                 protected
                end;

implementation

function BJump.getACopyOf:BElement;                                      // 1.26
var ele:BElement;
begin
  ele:=BJump.create;
  ele.comment.text:=self.comment.text;
  ele.text.Text:=self.text.Text;
  ele.color:=self.color;
  result:=ele;
end;

function BJump.PrepareDraw(_canvas:TCanvas): TRect;
var i:word;
begin
 rect.Top:=0;
 rect.Left:=0;
 rect.Right:=2*(E_PADDING div 2);

 for i:=0 to text.count-1 do
  if (rect.Right<coloredTextOutWidth(text[i],vars,colors,_canvas)+3*(E_PADDING div 2))
   then rect.Right:=coloredTextOutWidth(text[i],vars,colors,_canvas)+3*(E_PADDING div 2);

 rect.Bottom:=2*(E_PADDING div 2)+text.count*_canvas.TextHeight('O');
 result:=rect;
end;

procedure BJump.Draw(_canvas:TCanvas; _top_left:TRect);
var myrect:TRect;
    drawColor,colCol:TColor;
    i,p,w:word;
    fn:UTF8string;
begin
 drawColor:=clWhite;
 drawColor:=color;
 if (selected=true) then drawColor:=E_DRAWCOL;

 _canvas.Brush.Color:=clBlack;
 _canvas.FillRect(_top_left);

 rect:=_top_left;
 _canvas.brush.Color:=drawColor;
 myrect:=_top_left;
 myrect.Left:=myrect.Left+1;
 myrect.Top:=myrect.Top+1;
 myrect.bottom:=myrect.bottom-1;
 myrect.right:=myrect.right-1;
 _canvas.FillRect(myrect);
 if((trim(comment.Text)<>'')and(NSDUtils.flagDrawComments=true)) then
 begin
  colCol:=_canvas.Pen.Color;
  _canvas.Pen.Color:=commentColor;
  _canvas.Pen.Width:=2;
  _canvas.MoveTo(myrect.Left+2,myrect.Top+1);
  _canvas.LineTo(myrect.Left+2,myrect.Bottom-2);
  _canvas.Pen.Width:=1;
  _canvas.Pen.Color:=colCol;
 end;

 for i:=0 to text.Count-1 do
 begin
   text[i]:=AnsiReplaceStr(text[i],'<--','<-');

   coloredTextOut(text[i],vars,colors,_canvas,_top_left.Left+(E_PADDING div 2)+(E_PADDING div 2),
                   _top_left.Top+(E_PADDING div 2)+i*_canvas.TextHeight(text[i]));
 end;

 _canvas.MoveTo(_top_left.left+(E_PADDING div 2),_top_left.Top);
 _canvas.LineTo(_top_left.left,_top_left.Bottom+((_top_left.top-_top_left.bottom) div 2));
 _canvas.LineTo(_top_left.left+(E_PADDING div 2),_top_left.Bottom);

end;

function BJump.getXml:UTF8string;
begin
 result:='<jump text="'+xmlTransform(text.commatext)+'" comment="'+xmlTransform(comment.commatext)+'" color="'+Rev(Inttohex(Color,6))+'"></jump>';
end;

end.
