unit class_manager;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Process;
  
function Get_Bios_Serial: UTF8String;


implementation

function Get_Bios_Serial: UTF8String;
var aProc:TProcess;
    aOut:TStringList;
    i:integer;
    serial,s,comm,delim:string;
begin
{$IFDEF WIN32}
  comm:=#105#112#99#111#110#102#105#103#32#47#97#108#108;
  delim:='';
{$ELSE}
  {$IFDEF LINUX}
   comm:=#105#102#99#111#110#102#105#103#32#101#116#104#48;
   delim:=#72#87#97#100#100#114;
  {$ELSE}
   comm:=#105#102#99#111#110#102#105#103#32#101#110#48;
   delim:=#101#116#104#101#114;
  {$ENDIF}
{$ENDIF}

{$IFDEF WIN32}
  aProc:=TProcess.create(nil);
  aOut:=Tstringlist.create;
  aProc.CommandLine:=comm;
  aProc.Options:=AProc.Options + [poNoConsole, poUsePipes];
  aProc.Execute;
  aOut.LoadFromStream(aProc.Output);
  serial:='';
  for i:=0 to aOut.count-1 do
  begin
   s:=aOut[i];
   if((countSym(s,'-')=5)and(serial='')) then begin s:=trim(copy(s,pos('-',s)-2,length(s))); serial:=s; end;
   if((countSym(s,'.')=5)and(serial='')) then begin s:=trim(copy(s,pos('.',s)-2,length(s))); serial:=s; end;
  end;

  if(serial<>'') then
    for i:=length(serial) downto 0 do
      if((serial[i]=':')or(serial[i]='.')or(serial[i]='-')) then delete(serial,i,1);

  result:=trim(serial);
  aProc.free;
  aOut.free;
{$ELSE}
  aProc:=TProcess.create(nil);
  aOut:=Tstringlist.create;
  {$IFDEF LINUX}
  aProc.CommandLine:=comm;

  aProc.Options:=AProc.Options + [poWaitOnExit, poUsePipes];
  aProc.Execute;
  aOut.LoadFromStream(aProc.Output);

  for i:=0 to aOut.Count-1 do
    if(pos(delim,aOut[i])>0) then
    begin
     aOut[i]:=trim(aOut[i]);
     serial:=trim(copy(aOut[i],pos(delim,aOut[i])+length(delim),length(aOut[i])-(pos(delim,aOut[i])+length(delim))));
    end;
  {$ELSE}
  aProc.CommandLine:=comm;

  aProc.Options:=AProc.Options + [poWaitOnExit, poUsePipes];
  aProc.Execute;
  aOut.LoadFromStream(aProc.Output);

  for i:=0 to aOut.Count-1 do
    if(pos(delim,aOut[i])>0) then
    begin
     aOut[i]:=trim(aOut[i]);
     serial:=trim(copy(aOut[i],length(delim)+1,length(aOut[i])-length(delim)));
    end;
  {$ENDIF}

  if(serial<>'') then
    for i:=length(serial) downto 0 do
      if((serial[i]=':')or(serial[i]='.')or(serial[i]='-')) then delete(serial,i,1);

  result:=serial;

  aProc.free;
  aOut.free;
{$ENDIF}
end;


end.

