unit form_print;

interface

uses
  //WIN Windows,
  Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  //LAZ Preview,
  StdCtrls, ExtCtrls,
  Printers,
  LResources, PrintersDlgs;

type

  { TfrmPrint }

  TfrmPrint = class(TForm)
    FormComboBox1: TComboBox;
    lblOrientation1: TLabel;
    lblPaper1: TLabel;
    lblZoom1: TLabel;
    lbOrient1: TComboBox;
    lbZoom1: TComboBox;
    PrintDialog: TPrintDialog;
    PrinterSetupDialog: TPrinterSetupDialog;
    //LAZ PrintPreview: TPrintPreview;
    Toolbar: TPanel;
    Panel1: TPanel;
    btnOK: TButton;
    btmCancel: TButton;
    //LAZ PrinterSetupDialog: TPrinterSetupDialog;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure lbZoomChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormComboBoxChange(Sender: TObject);
    procedure PrintPreviewZoomChange(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lblPaperClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure makeIt;
  end;
  
var
    frmPrint: TfrmPrint;                  // 1.25



implementation

uses form_main;


procedure TfrmPrint.lbZoomChange(Sender: TObject);
begin
//LAZ
{
  case lbZoom.ItemIndex of
    0: PrintPreview.Zoom := 50;
    1: PrintPreview.Zoom := 100;
    2: PrintPreview.Zoom := 150;
    3: PrintPreview.Zoom := 200;
    4: PrintPreview.ZoomState := zsZoomToWidth;
    5: PrintPreview.ZoomState := zsZoomToHeight;
    6: PrintPreview.ZoomState := zsZoomToFit;
  end;
}
end;

procedure TfrmPrint.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin

end;

procedure TfrmPrint.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin

end;

procedure TfrmPrint.FormCreate(Sender: TObject);
begin
//LAZ
{
  PrintPreview.Zoom := 100;
  PrintPreview.FetchFormNames(FormComboBox.Items);
  FormComboBox.ItemIndex := FormComboBox.Items.IndexOf(PrintPreview.FormName);
}
end;

procedure TfrmPrint.makeIt;
var r:trect;
begin
//LAZ
{
 with self.PrintPreview do
 begin
   if FormComboBox.ItemIndex >= 0 then
     FormName := FormComboBox.Items[FormComboBox.ItemIndex];
   R := PageBounds;
   with ConvertXY(150, 150, mmLoMetric, Units) do InflateRect(R, -X, -Y);
   BeginDoc;
   PaintGraphicEx(r,(self.owner as tmainform).image.Picture.Graphic,true,false,true);
   EndDoc;
   PrintPreview.ZoomState := zsZoomToFit;
 end;
}
end;

procedure TfrmPrint.FormComboBoxChange(Sender: TObject);
begin
//LAZ
{
 if(lbOrient.ItemIndex=0) then PrintPreview.Orientation:=poPortrait
 else PrintPreview.Orientation:=poLandscape;
 makeIt;
}
end;

procedure TfrmPrint.PrintPreviewZoomChange(Sender: TObject);
begin
//LAZ
{
  case PrintPreview.ZoomState of
    zsZoomToFit: lbZoom.ItemIndex := 6;
    zsZoomToHeight: lbZoom.ItemIndex := 5;
    zsZoomToWidth: lbZoom.ItemIndex := 4;
  else
    case PrintPreview.Zoom of
      200: lbZoom.ItemIndex := 3;
      150: lbZoom.ItemIndex := 2;
      100: lbZoom.ItemIndex := 1;
      50: lbZoom.ItemIndex := 0;
    else
      lbZoom.ItemIndex := -1;
    end;
  end;
}
end;

procedure TfrmPrint.btnOKClick(Sender: TObject);
var pRect,dRect:Trect;
begin
//LAZ
(*
  if PrintPreview.State = psReady then
  begin
    PrintPreview.SetPrinterOptions;
*)
    if PrintDialog.Execute then
    begin
      printer.BeginDoc;
      dRect.top:=0;
      dRect.left:=0;
      dRect.right:=mainform.Image.Picture.bitmap.Width;
      dRect.bottom:=mainform.Image.Picture.bitmap.height;

//      mainform.root.draw(printer.canvas);
//      printer.Canvas.CopyRect(dRect,mainform.image.canvas,drect);
      printer.Canvas.StretchDraw(dRect,mainform.image.picture.bitmap);
//      printer.PaintGraphicEx(r,(self.owner as tmainform).image.Picture.Graphic,true,false,true);
      printer.EndDoc;
//      PrintPreview.UpdateAnnotation;
//      PrintPreview.Print;
    end;
(*
  end;
*)
end;

procedure TfrmPrint.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//WIN  if(key=vk_escape) then modalresult:=mrcancel;
end;

procedure TfrmPrint.lblPaperClick(Sender: TObject);
begin

end;

initialization
  {$I form_print.lrs}


end.
